#pragma once
#include <stdio.h>
//
// $Date: 2019-02-27 14:37:18 +0100 (wo, 27 feb 2019) $
// $Revision: 69722 $
// $Author: jansink $
// $HeadURL: https://192.168.51.1/DMS-Houtribdijk/code/bin2asc/sourceADV/adv2asc.h $
//
//

#pragma pack(push)
#pragma pack(1)  // 1 byte struct member alignment used in firmware

//////////////////////////////////////////////////////////////////////////////

// Clock data (6 bytes) NOTE! BCD format
typedef struct {
  unsigned char cMinute; // minute
  unsigned char cSecond; // second
  unsigned char cDay; // day
  unsigned char cHour; // hour
  unsigned char cYear; // year
  unsigned char cMonth; // month
} PdClock;


//
// Vector velocity data 3 beams(10 + f(nBeams) bytes)
typedef struct {
  unsigned char  cSync;         // sync = 0xa5
  unsigned char  cId;           // identification = 0x10
  unsigned char  cAnaIn2LSB;    // analog input 2 LSB
  unsigned char  cCount;        // ensemble counter
  unsigned char  cPressureMSB;  // pressure MSB
  unsigned char  cAnaIn2MSB;    // analog input 2 MSB
  unsigned short hPressureLSW;  // pressure LSW
  unsigned short hAnaIn1;       // analog input 1 (fast)
  short          hVel[3];       // velocity
  unsigned char  cAmp[3];       // amplitude
  unsigned char  cCorr[3];      // correlation  (0-100)
  unsigned short hChecksum;     // checksum
} PdVecVel;

//
// Vector system data (28 bytes)

typedef struct {
  unsigned char  cSync;         // sync = 0xa5
  unsigned char  cId;           // identification = 0x11
  unsigned short hSize;         // size of structure (words)
  PdClock        clock;         // date and time
  unsigned short hBattery;      // battery voltage (0.1 V)
  unsigned short hSoundSpeed;   // speed of sound (0.1 m/s)
  short          hHeading;      // compass heading (0.1 deg)
  short          hPitch;        // compass pitch (0.1 deg)
  short          hRoll;         // compass roll (0.1 deg)
  short          hTemperature;  // temperature (0.01 deg C)
  char           cError;        // error code
  char           cStatus;       // status
  unsigned short hAnaIn;        // analog input (slow)
  unsigned short hChecksum;
} PdVecSys;

char *decimal_to_binary(char);

unsigned short Checksum(short *, int);
